//Copyright 2017 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef bncSQLColumn_H
#define bncSQLColumn_H
#include <string.h>

#include <bncsql.h>
#ifdef bncSQL_DEBUG
# define bncSQLColumn_DEBUG
#endif
#ifdef bncSQLColumn_DEBUG
# include <albus_log.h>
#endif


//field type
#define bn_char             0x00000001
#define bn_long             0x00000002
#define bn_long_long        0x00000004
#define bn_double           0x00000008
#define bn_blob             0x00000010
#define bn_IS_NULL          0x00000020
//field flag naming from mysql
#define bn_NOT_NULL         0x00000100
#define bn_PRI_KEY          0x00000200
#define bn_UNIQUE_KEY       0x00000400
#define bn_MULTIPLE_KEY     0x00000800
#define bn_BLOB             0x00001000
#define bn_UNSIGNED         0x00002000
#define bn_ZEROFILL         0x00004000
#define bn_BINARY           0x00008000
#define bn_ENUM             0x00010000
#define bn_AUTO_INCREMENT   0x00020000
#define bn_TIMESTAMP        0x00040000
#define bn_SET              0x00080000
#define bn_NO_DEFAULT_VALUE 0x00100000
#define bn_ON_UPDATE_NOW    0x00200000
#define bn_NUM              0x00400000
#define bn_PART_KEY         0x00800000
#define bn_GROUP            0x01000000
#define bn_UNIQUE           0x02000000
//efine bn_BINCMP           0x04000000 ! @ WIN32


class _bncColumn {
private:
    char  GetBuffer[100];

public:

      void *New         ( const void *nData );
      void *Destructor  ( void );
      void *Clean       ( void );
      char *Show        ( void );
//Set
      void *Set         ( const unsigned char *sData, unsigned long sLen );
      void *Set         ( const unsigned char *sData     );
      void *SetChar     ( const unsigned char *sData     );
      void *SetLong     (                long  sLong     );
      void *SetLongLong (           long long  sLongLong );
      void *SetDouble   (              double  sDouble   );
      void *SetBlob     ( const unsigned char *sData, unsigned long sLen );
//Get
const char *Get         ( void );
      char *GetChar     ( void );
      long *GetLong     ( void );
 long long *GetLongLong ( void );
    double *GetDouble   ( void );
      void *GetBlob     ( unsigned char **gData, unsigned long *gLen );

         char  Error[255]; //2do char *, link 2 tb->Error
         char *Name;
 unsigned int  Type;
         void *Data;
unsigned long *Size;
unsigned long *SizeExtern;
         char *Format;
         char *FormatExtern;
         long  Scale;  //%Size.Scale f

    _bncColumn () {
#ifdef  bncSQLColumn_DEBUG
	D7 ( "this=%p", this );//best D7
#endif
	memset ( this, 0x00, sizeof ( _bncColumn ) );
	Scale = 2;
	 Size = new unsigned long;
	*Size = 0;
    }

    ~_bncColumn () {
#ifdef  bncSQLColumn_DEBUG
	D7 ( "this=%p", this );//best D7
#endif
	Destructor ();
	bn_free ( Data   );
	bn_free ( Name   );
	bn_free ( Size   );
	bn_free ( Format );
    }

    void *DataExtern;
    void *Extern;

};

#endif
